unit display;

interface
// Display the results of computing pi.
// The user can copy the results to the clipboard or save
// them to a file.
//
// Copyright  2002 Tempest Software, Inc.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Menus, StdActns, ActnList,
  ImgList, ToolWin;

type
  TDisplayPi = class(TForm)
    RichEdit1: TRichEdit;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ActionList1: TActionList;
    ImageList1: TImageList;
    EditCopy1: TEditCopy;
    EditSelectAll1: TEditSelectAll;
    FileSaveAs1: TFileSaveAs;
    ToolButton3: TToolButton;
    PopupMenu1: TPopupMenu;
    Copy1: TMenuItem;
    SelectAll1: TMenuItem;
    N1: TMenuItem;
    SaveAs1: TMenuItem;
    N2: TMenuItem;
    Close1: TMenuItem;
    SaveDialog1: TSaveDialog;
    WindowClose: TAction;
    procedure WindowCloseExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure DisplayPi(const Pi: string);

implementation

uses Clipbrd;

{$R *.dfm}

procedure DisplayPi(const Pi: string);
var
  Form: TDisplayPi;
begin
  Form := TDisplayPi.Create(Application);
  try
    // The Spigot algorithm dumps a leading 0 at the start of the
    // digit string. Pretty up the result by eliminating it, but
    // be defensive in case the computational algorithm is changed
    // sometime in the future.
    if (Length(Pi) > 0) and (Pi[1] = '0') then
      Form.RichEdit1.Text := Copy(Pi, 2, MaxInt)
    else
      Form.RichEdit1.Text := Pi;
    Form.ShowModal;
  finally
    Form.Free;
  end;
end;

procedure TDisplayPi.WindowCloseExecute(Sender: TObject);
begin
  Close;
end;

end.

